{===
Rodent v1.0, a demo to thrive at expense of the system.
Copyright (C) 2019 Marco Borsari

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

You may contact me at address <borsa77@libero.it> or you can
compile by yourself with Turbo Pascal 5.5+ or Free Pascal 2.0.4+.
===}

Program Rodent;
{$R-,S-,N+,E+}
{$IFDEF go32v2}
Uses emu387;
{$ENDIF}

Const max = 5;
  lim = 0.85;

Type float = double;

Var pr,nr,vA,vB,gcA,scA,gfB,sfB: integer;
  ps,mA,mB: float;
  ft,pA,pB: array[0..max] of float;
  i,j: integer;
  p1,p2,pX: float;

Function Poisson(gl:integer;mp:float): float;
Begin
  Poisson := exp(gl*ln(mp)-mp)/ft[gl];
end;

Begin
  writeln('Rodent v1.0, Copyright (C) 2019, Marco Borsari');
  writeln('Rodent comes with ABSOLUTELY NO WARRANTY.');
  writeln('This is free software, and you are welcome');
  writeln('to redistribute it under the terms of GNU GPL.');
  writeln;
  (*precalcola i fattoriali*)
  ft[0] := 1.0;
  For i := 1 To max Do
    ft[i] := ft[i-1]*i;
  writeln('The team A plays as home.');
  writeln('The team B comes as visitor.');
  write('Number of forecasts: ');
  readln(pr);
  Repeat
    write('Number of past matches: ');
    readln(nr);
  Until nr>0;
  While pr>0 Do
    Begin
      write('Total victories of A: ');
      readln(vA);
      write('Total victories of B: ');
      readln(vB);
      write('Goals scored at home by A: ');
      readln(gcA);
      write('Goals conceded at home by A: ');
      readln(scA);
      write('Goals scored away by B: ');
      readln(gfB);
      write('Goals conceded away by B: ');
      readln(sfB);
      dec(pr);
      (*calcola le medie pesate*)
      ps := (vA-vB)/nr;
      mA := ((1.0+ps)*gcA+sfB)/nr;
      ps := -ps;
      mB := ((1.0+ps)*gfB+scA)/nr;
      If (mA<=0.0) Or (mB<=0.0) Then
        Begin
          writeln('Does not compute.');
          continue;
        End;
      (*trova le probabilita' dei goal*)
      For i := 0 To max Do
        Begin
          pA[i] := Poisson(i,mA);
          pB[i] := Poisson(i,mB);
          (*sconta il catenaccio dell'avversario*)
          If i=1 Then
            Begin
              If pA[i]>lim Then
                pA[i] := lim;
              If pB[i]>lim Then
                pB[i] := lim;
            End;
        End;
      (*calcola la probabilita' per l'1 e il 2*)
      p1 := 0.0;
      p2 := 0.0;
      For i := 1 To max Do
        For j := 0 To i-1 Do
          Begin
            p1 := p1+pA[i]*pB[j];
            p2 := p2+pB[i]*pA[j];
          End;
      (*calcola la probabilita' per la X*)
      pX := 0.0;
      For i := 0 To max Do
        pX := pX+pA[i]*pB[i];
      (*rinormalizza causa il troncamento sul massimo
      di goal e il tetto per il catenaccio*)
      ps := p1+p2+pX;
      p1 := p1/ps;
      p2 := p2/ps;
      pX := 1.0-(p1+p2);
      writeln('1=',round(100.0*p1),'% X=',round(100.0*pX),
        '% 2=',round(100.0*p2),'%, ',round(mA),'-',round(mB));
    End;
End.
